diff --git a/lib/hive/commands/setup.rb b/lib/hive/commands/setup.rb
new file mode 100644
index 00000000..fafa5355
--- /dev/null
+++ b/lib/hive/commands/setup.rb
@@ -0,0 +1,268 @@
+require "json"
+require "hive/config"
+require "hive/invoked_binary"
+require "hive/setup/diagnostics"
+require "hive/setup/qmd_installer"
+require "hive/web/app_bundle"
+require "hive/web/loopback"
+require "hive/commands/init"
+require "hive/commands/daemon"
+require "hive/commands/daemon/service_installer"
+require "hive/commands/web/service_installer"
+
+module Hive
+  module Commands
+    # Phase-oriented native install. It owns the orchestration boundary while
+    # leaving qmd, Rails bundle, enrollment, and each service installer as
+    # independently testable components.
+    class Setup
+      Phase = Data.define(:name, :status, :message, :detail) do
+        def ok?
+          %w[ok unchanged skipped].include?(status)
+        end
+
+        def to_h
+          { "name" => name, "status" => status, "message" => message, "detail" => detail }
+        end
+      end
+
+      VALID_ONLY = %w[qmd].freeze
+
+      def initialize(project_path = Dir.pwd, diagnose_only: false, json: false, force: false,
+                     service: true, only: nil, diagnostics: nil, qmd_installer: nil,
+                     app_bundle: nil, init_command: nil, daemon_installer: nil,
+                     web_installer: nil, stdout: $stdout, stderr: $stderr)
+        @project_path = File.expand_path(project_path)
+        @diagnose_only = diagnose_only
+        @json = json
+        @force = force
+        @service = service
+        @only = only
+        @diagnostics = diagnostics
+        @qmd_installer = qmd_installer
+        @app_bundle = app_bundle
+        @init_command = init_command
+        @daemon_installer = daemon_installer
+        @web_installer = web_installer
+        @stdout = stdout
+        @stderr = stderr
+        @phases = []
+      end
+
+      def call
+        validate_only!
+        return run_qmd_only if @only == "qmd"
+
+        report = diagnostics.call
+        diagnostics_ok = @diagnose_only ? report.healthy? : external_failures(report).empty?
+        add("diagnostics", diagnostics_ok ? "ok" : "failed", diagnostic_message(report), report.to_h)
+        if @diagnose_only
+          emit
+          return report.healthy? ? 0 : 1
+        end
+
+        if external_failures(report).any?
+          skip_remaining("external prerequisites are not healthy")
+          emit
+          return 1
+        end
+
+        ensure_qmd(report)
+        ensure_web_bundle
+        validate_owned_assets
+        unless @phases.all?(&:ok?)
+          skip_remaining("Hive-owned bootstrap did not complete")
+          emit
+          return 1
+        end
+
+        enroll_project
+        ensure_services if @service
+        add("services", "skipped", "service supervision disabled by --no-service", nil) unless @service
+        emit
+        @phases.all?(&:ok?) ? 0 : 1
+      rescue Hive::Error, ArgumentError => error
+        add("setup", "failed", error.message, nil)
+        emit
+        1
+      end
+
+      private
+
+      attr_reader :phases
+
+      def diagnostics
+        @diagnostics ||= Hive::Setup::Diagnostics.new(
+          rails_ready: -> { app_bundle.resolve },
+          sqlite_ready: -> { true }
+        )
+      end
+
+      def qmd_installer
+        @qmd_installer ||= Hive::Setup::QmdInstaller.new
+      end
+
+      def app_bundle
+        @app_bundle ||= Hive::Web::AppBundle.new
+      end
+
+      def validate_only!
+        return if @only.nil? || VALID_ONLY.include?(@only)
+
+        raise ArgumentError, "hive setup: unsupported --only=#{@only.inspect} (expected: #{VALID_ONLY.join(', ')})"
+      end
+
+      def run_qmd_only
+        result = qmd_installer.install
+        add("qmd", result.ok? ? (result.status == "unchanged" ? "unchanged" : "ok") : "failed", result.message, result.to_h)
+        emit
+        result.ok? ? 0 : 1
+      end
+
+      def external_failures(report)
+        report.results.reject(&:ok?).select { |result| result.ownership == "external" }
+      end
+
+      def diagnostic_message(report)
+        failed = report.results.reject(&:ok?)
+        return "all prerequisites are healthy" if failed.empty?
+
+        "#{failed.size} prerequisite#{failed.size == 1 ? '' : 's'} need attention"
+      end
+
+      def ensure_qmd(report)
+        check = report.fetch("qmd")
+        if check.ok?
+          add("qmd", "unchanged", "qmd is ready", check.to_h)
+          return
+        end
+
+        result = qmd_installer.install
+        add("qmd", result.ok? ? "ok" : "failed", result.message, result.to_h)
+      end
+
+      def ensure_web_bundle
+        if app_bundle.resolve
+          add("web_bundle", "unchanged", "matching Rails app is ready", { "path" => app_bundle.resolve })
+          return
+        end
+
+        archive = ENV["HIVE_WEB_ARCHIVE"]
+        digest = ENV["HIVE_WEB_ARCHIVE_SHA256"]
+        if archive.to_s.empty? || digest.to_s.empty?
+          add("web_bundle", "failed", "matching Rails bundle is absent; set HIVE_WEB_ARCHIVE and HIVE_WEB_ARCHIVE_SHA256 from the signed release manifest", nil)
+          return
+        end
+
+        result = app_bundle.install_from_archive!(archive, expected_sha256: digest)
+        add("web_bundle", result.ok? ? "ok" : "failed", result.message, result.to_h)
+      end
+
+      def validate_owned_assets
+        add("owned_validation", "ok", "Hive-owned dependencies were validated by their installers", nil)
+      end
+
+      def enroll_project
+        raise Hive::InvalidTaskPath, "hive setup: #{project_path} is not a git repository" unless git_repository?
+
+        enroll_project_state
+        enroll_daemon
+      rescue StandardError => error
+        add("project_enrollment", "failed", error.message, { "path" => project_path })
+      end
+
+      def enroll_project_state
+        if File.directory?(File.join(project_path, ".hive-state"))
+          Hive::Config.register_project(name: File.basename(project_path), path: project_path)
+          add("project_enrollment", "unchanged", "project is registered", { "path" => project_path })
+        else
+          command = @init_command || Hive::Commands::Init.new(project_path, force: @force, install_daemon_service: false)
+          command.call
+          add("project_enrollment", "ok", "project initialized and registered", { "path" => project_path })
+        end
+      end
+
+      def enroll_daemon
+        Hive::Commands::Daemon.new("enable", File.basename(project_path)).enrollment_results(enabled: true)
+        add("daemon_enrollment", "ok", "daemon.enabled is durable for this project", { "project" => File.basename(project_path) })
+      rescue StandardError => error
+        add("daemon_enrollment", "failed", error.message, { "project" => File.basename(project_path) })
+      end
+
+      def ensure_services
+        return unless phases.all?(&:ok?)
+
+        binary = Hive::InvokedBinary.path
+        if binary.to_s.empty?
+          add("services", "failed", "could not resolve the invoking Hive executable", nil)
+          return
+        end
+
+        daemon = @daemon_installer || Hive::Commands::Daemon::ServiceInstaller.new(binary_path: binary)
+        daemon_result = daemon.install!(autostart: true, force: @force)
+        daemon_message = daemon.messages.join("; ")
+        daemon_message = daemon_result.wire_outcome if daemon_message.empty?
+        add("daemon_service", daemon_result.success? ? "ok" : "failed", daemon_message,
+            { "path" => daemon.target_path, "outcome" => daemon_result.wire_outcome, "binary" => binary })
+
+        return unless daemon_result.success?
+
+        config = Hive::Config.load_global_web
+        bind = config.fetch("bind")
+        port = config.fetch("port")
+        policy = Hive::Web::Loopback.policy!(bind: bind, config: config)
+        web = @web_installer || Hive::Commands::Web::ServiceInstaller.new(
+          binary_path: binary, bind: bind, port: port, local_mode: policy.local_mode?, unsafe_no_auth: policy.unsafe?
+        )
+        web_result = web.install!(autostart: true, force: @force)
+        web_message = web.messages.join("; ")
+        web_message = web_result.wire_outcome if web_message.empty?
+        add("web_service", web_result.success? ? "ok" : "failed", web_message,
+            { "path" => web.target_path, "outcome" => web_result.wire_outcome, "binary" => binary })
+      rescue StandardError => error
+        add("services", "failed", error.message, nil)
+      end
+
+      def skip_remaining(message)
+        %w[qmd web_bundle owned_validation project_enrollment daemon_enrollment daemon_service web_service].each do |name|
+          next if phases.any? { |phase| phase.name == name }
+
+          add(name, "skipped", message, nil)
+        end
+      end
+
+      def add(name, status, message, detail)
+        return if phases.any? { |phase| phase.name == name && status == "skipped" }
+
+        phases << Phase.new(name, status, message, detail)
+      end
+
+      def emit
+        payload = {
+          "schema" => "hive-setup",
+          "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-setup"),
+          "ok" => phases.all?(&:ok?),
+          "project" => project_path,
+          "url" => "http://127.0.0.1:4567",
+          "phases" => phases.map(&:to_h)
+        }
+        if @json
+          @stdout.puts(JSON.generate(payload))
+        else
+          phases.each { |phase| @stdout.puts("hive setup: #{phase.name}: #{phase.status} — #{phase.message}") }
+          @stdout.puts("hive setup: open #{payload.fetch('url')}") if payload.fetch("ok") && @service
+        end
+      end
+
+      def project_path
+        @project_path
+      end
+
+      # A linked Git worktree has a `.git` file pointing at shared metadata;
+      # a primary checkout has a `.git` directory. Both are valid setup roots.
+      def git_repository?
+        File.exist?(File.join(project_path, ".git"))
+      end
+    end
+  end
+end
diff --git a/lib/hive/commands/web.rb b/lib/hive/commands/web.rb
index eb3cd40f..26e9b23f 100644
--- a/lib/hive/commands/web.rb
+++ b/lib/hive/commands/web.rb
@@ -1,87 +1,148 @@
+require "fileutils"
+require "json"
 require "hive/config"
+require "hive/invoked_binary"
+require "hive/web/app_bundle"
+require "hive/web/loopback"
 require "hive/web/session_secret"
 
 module Hive
   module Commands
-    # Boots the hivebox web UI — a Rails app living in web/ at the repo root
-    # (shipped in the Docker image at /app/web). hive itself stays a plain
-    # CLI gem; the web tier is only supported where the Rails app and its
-    # bundle exist: the hivebox container or a source checkout.
+    # Bare `hive web` deliberately stays attached to the terminal. Lifecycle
+    # verbs operate on a distinct per-user service rather than hiding a second
+    # foreground alias behind `start`.
     class Web
-      def initialize(bind: nil, port: nil)
+      VALID_ACTIONS = %w[install start stop restart status].freeze
+
+      def initialize(bind: nil, port: nil, action: nil, force: false, unsafe_no_auth: false, json: false)
         @bind = bind
         @port = port
+        @action = action
+        @force = force
+        @unsafe_no_auth = unsafe_no_auth
+        @json = json
       end
 
       def call
-        cfg = Hive::Config.load_global_web
-        bind = @bind || cfg.fetch("bind")
-        port = (@port || cfg.fetch("port")).to_i
+        return lifecycle! if @action
+
+        foreground!
+      end
+
+      private
+
+      def foreground!
+        cfg, bind, port, policy = resolved_configuration
         app_dir = rails_app_dir
         unless app_dir
-          warn "hive web: the hivebox web app (web/) was not found. " \
-               "Run from the hivebox Docker image or a source checkout, " \
-               "or point HIVEBOX_WEB_APP_DIR at the Rails app."
+          warn "hive web: the native web app was not found. Run `hive setup` to install the matching " \
+               "web bundle, use hivebox, or point HIVEBOX_WEB_APP_DIR at a Rails app."
           exit 1
         end
 
-        warn_on_public_bind(bind, cfg)
-
-        env = {
-          "RAILS_ENV" => ENV.fetch("RAILS_ENV", "production"),
-          # Rails' secret_key_base derives from the same persisted secret the
-          # session cookies used pre-Rails, so recreating the container keeps
-          # sessions (the file lives on the /data mount).
-          "SECRET_KEY_BASE" => ENV["SECRET_KEY_BASE"] ||
-            Hive::Web::SessionSecret.load_or_create(cfg.fetch("session_secret_file")),
-          "HIVEBOX_ORIGIN" => cfg.fetch("origin"),
-          # The solid_cable/cache/queue sqlite files must survive image
-          # upgrades — keep them in state_home (on /data in the container),
-          # not in the app dir.
-          "HIVEBOX_STORAGE_DIR" => ENV["HIVEBOX_STORAGE_DIR"] ||
-            File.join(Hive::Paths.state_home, "web-storage"),
-          "BUNDLE_GEMFILE" => File.join(app_dir, "Gemfile")
-        }
+        warn_on_public_bind(bind, cfg, policy)
+        env = rails_environment(cfg, app_dir, bind, port, policy)
         FileUtils.mkdir_p(env.fetch("HIVEBOX_STORAGE_DIR"))
 
         Dir.chdir(app_dir) do
-          # Idempotent: creates/migrates the solid-stack sqlite databases on
-          # first boot, no-ops afterwards. Array form — no shell involved.
-          # Typed error so a persistent failure surfaces as guidance, not a
-          # raw backtrace looping every 5s under the container supervisor.
           unless system(env, "bin/rails", "db:prepare")
             raise Hive::Error,
-                  "hive web: db:prepare failed — check that " \
-                  "#{env.fetch("HIVEBOX_STORAGE_DIR")} is writable (the /data mount) " \
+                  "hive web: db:prepare failed — check that #{env.fetch("HIVEBOX_STORAGE_DIR")} is writable " \
                   "and that the web bundle is installed (cd #{app_dir} && bundle install)"
           end
           puts "hive web: listening on http://#{bind}:#{port}"
-          # Replace this process with the Rails server (array form, env hash;
-          # Kernel#exec never touches a shell when given an argv list).
           Kernel.exec env, "bin/rails", "server", "-b", bind, "-p", port.to_s
         end
       end
 
-      private
+      def lifecycle!
+        raise Hive::InvalidTaskPath, "hive web: unknown action #{@action.inspect} (expected: #{VALID_ACTIONS.join(', ')})" unless VALID_ACTIONS.include?(@action)
+
+        cfg, bind, port, policy = resolved_configuration
+        require "hive/commands/web/service_installer"
+        installer = service_installer(bind, port, policy)
+
+        case @action
+        when "install"
+          outcome = installer.install!(autostart: false, force: @force)
+          emit_lifecycle(installer.lifecycle_status.merge("outcome" => outcome.wire_outcome, "messages" => installer.messages))
+          raise Hive::Error, "web service definition differs; re-run `hive web install --force`" if outcome.drifted?
+          raise Hive::Error, "web service installation failed" if outcome.failed?
+        when "status"
+          emit_lifecycle(installer.lifecycle_status)
+        else
+          unless installer.control!(@action)
+            raise Hive::Error, "hive web: could not #{@action} managed web service; install it first with `hive web install`"
+          end
+          emit_lifecycle(installer.lifecycle_status.merge("action" => @action))
+        end
+      end
+
+      def emit_lifecycle(payload)
+        if @json
+          puts JSON.generate(payload.merge("schema" => "hive-web-service-status", "schema_version" => 1, "ok" => true))
+        else
+          status = payload.fetch("status")
+          puts "hive web: #{status.tr('_', ' ')}"
+          Array(payload["messages"]).each { |message| warn "hive web: #{message}" }
+        end
+      end
+
+      def resolved_configuration
+        cfg = Hive::Config.load_global_web
+        bind = @bind || cfg.fetch("bind")
+        port = (@port || cfg.fetch("port")).to_i
+        policy = Hive::Web::Loopback.policy!(bind: bind, config: cfg, unsafe_no_auth: @unsafe_no_auth)
+        [ cfg, bind, port, policy ]
+      end
+
+      def rails_environment(cfg, app_dir, bind, port, policy)
+        {
+          "RAILS_ENV" => ENV.fetch("RAILS_ENV", "production"),
+          "SECRET_KEY_BASE" => ENV["SECRET_KEY_BASE"] || Hive::Web::SessionSecret.load_or_create(cfg.fetch("session_secret_file")),
+          "HIVEBOX_ORIGIN" => cfg.fetch("origin"),
+          "HIVEBOX_STORAGE_DIR" => ENV["HIVEBOX_STORAGE_DIR"] || File.join(Hive::Paths.state_home, "web-storage"),
+          "BUNDLE_GEMFILE" => File.join(app_dir, "Gemfile"),
+          "HIVE_WEB_LOCAL_LOOPBACK" => policy.local_mode? ? "1" : "0",
+          "HIVE_WEB_UNSAFE_NO_AUTH" => policy.unsafe? ? "1" : "0",
+          "HIVE_WEB_BIND" => bind,
+          "HIVE_WEB_PORT" => port.to_s,
+          # The Rails maintenance path must repair the daemon with the same
+          # stable wrapper that launched this web process, never by guessing
+          # `hive` from an arbitrary service-manager PATH.
+          "HIVE_INVOKED_BIN" => Hive::InvokedBinary.path || $PROGRAM_NAME,
+          # Hivebox retains its existing supervisor/queue topology. Native
+          # foreground and managed runs use Puma's supported local worker.
+          "SOLID_QUEUE_IN_PUMA" => ENV["HIVEBOX_WEB_APP_DIR"] == "/app/web" ? ENV.fetch("SOLID_QUEUE_IN_PUMA", "0") : "1"
+        }
+      end
+
+      def service_installer(bind, port, policy)
+        ServiceInstaller.new(
+          binary_path: Hive::InvokedBinary.path || $PROGRAM_NAME,
+          bind: bind,
+          port: port,
+          local_mode: policy.local_mode?,
+          unsafe_no_auth: policy.unsafe?
+        )
+      end
 
       def rails_app_dir
-        candidates = [
-          ENV["HIVEBOX_WEB_APP_DIR"],
-          File.expand_path("../../../web", __dir__)
-        ].compact
-        candidates.find { |dir| File.file?(File.join(dir, "config", "application.rb")) }
+        Hive::Web::AppBundle.new.resolve
       end
 
-      # Rails' production host authorization is inactive by default — the box
-      # assumes a trusted reverse proxy validates Host, exactly like the
-      # pre-Rails posture. Binding a public interface without that proxy
-      # exposes the app to DNS-rebinding / Host-injection, so make it loud.
-      def warn_on_public_bind(bind, cfg)
-        return unless bind.to_s == "0.0.0.0"
-        return if cfg["origin"].to_s.start_with?("https://")
+      # Retained as a small unit-test seam. The policy check itself is the
+      # enforcement point; this only makes an explicit unsafe escape hatch
+      # impossible to overlook in logs.
+      def warn_on_public_bind(bind, cfg, policy = nil)
+        return if Hive::Web::Loopback.listener?(bind)
+        if policy
+          return unless policy.unsafe?
 
-        warn "hive web: WARNING binding 0.0.0.0 without an https origin — " \
-             "ensure a trusted reverse proxy validates the Host header."
+          warn "hive web: WARNING binding #{bind} in unsafe no-auth mode; do not expose it beyond a trusted network"
+        elsif !cfg.fetch("origin", "").to_s.start_with?("https://")
+          warn "hive web: WARNING binding #{bind} without an https origin — ensure a trusted reverse proxy validates the Host header."
+        end
       end
     end
   end
diff --git a/lib/hive/commands/web/service_installer.rb b/lib/hive/commands/web/service_installer.rb
new file mode 100644
index 00000000..bb7513a5
--- /dev/null
+++ b/lib/hive/commands/web/service_installer.rb
@@ -0,0 +1,90 @@
+require "cgi"
+require "shellwords"
+require "hive/commands/service_installer/base"
+
+module Hive
+  module Commands
+    class Web
+      class ServiceInstaller < Hive::Commands::ServiceInstaller::Base
+        SAFE_ENV_KEYS = %w[HIVE_HOME XDG_CONFIG_HOME XDG_DATA_HOME XDG_STATE_HOME XDG_CACHE_HOME XDG_BIN_HOME].freeze
+
+        def initialize(bind:, port:, local_mode: true, unsafe_no_auth: false, environment: ENV, **kwargs)
+          super(**kwargs)
+          @bind = bind
+          @port = port.to_i
+          @local_mode = local_mode
+          @unsafe_no_auth = unsafe_no_auth
+          @environment = environment
+        end
+
+        def service_name = "hive-web"
+        def cli_label = "web"
+        def service_noun = "web service"
+        def unit_noun = "web unit"
+
+        def target_path
+          case platform
+          when :macos then File.join(@home, "Library/LaunchAgents/local.hive-web.plist")
+          when :linux then File.join(@home, ".config/systemd/user/hive-web.service")
+          end
+        end
+
+        private
+
+        def web_arguments
+          args = [ "web", "--bind", @bind, "--port", @port.to_s ]
+          args << "--unsafe-no-auth" if @unsafe_no_auth
+          args
+        end
+
+        def render_systemd
+          template = File.read(File.expand_path("../../../../examples/systemd/hive-web.service", __dir__))
+          command = ([ Shellwords.escape(resolved_binary) ] + web_arguments.map { |arg| Shellwords.escape(arg) }).join(" ")
+          environment = systemd_environment_lines
+          template
+            .sub(/^ExecStart=.*$/, "ExecStart=#{command}")
+            .sub(/^Environment=PATH=.*$/, build_path_line)
+            .sub("# HIVE_WEB_ENVIRONMENT", environment)
+        end
+
+        def render_launchd
+          template = File.read(File.expand_path("../../../../examples/launchd/hive-web.plist", __dir__))
+          binary = resolved_binary
+          args = web_arguments.map { |arg| "    <string>#{CGI.escapeHTML(arg)}</string>" }.join("\n")
+          template
+            .gsub(%r{<string>/Users/YOU/\.local/bin/hive</string>}, "<string>#{CGI.escapeHTML(binary)}</string>")
+            .gsub("    <!-- HIVE_WEB_ARGUMENTS -->", args)
+            .gsub("/Users/YOU/Library/Logs", "#{CGI.escapeHTML(@home)}/Library/Logs")
+            .gsub("/Users/YOU/.local/bin", CGI.escapeHTML(File.dirname(binary)))
+            .gsub("    <!-- HIVE_WEB_ENVIRONMENT -->", launchd_environment_lines)
+        end
+
+        def selected_environment
+          selected = @environment.each_with_object({}) do |(key, value), memo|
+            next unless SAFE_ENV_KEYS.include?(key)
+            next if value.to_s.empty?
+
+            memo[key] = value
+          end
+          # This path is selected by Hive itself (not copied from ambient
+          # environment) and is needed by Rails' typed daemon-repair action
+          # to preserve executable identity across a web-service restart.
+          selected["HIVE_INVOKED_BIN"] = resolved_binary
+          selected
+        end
+
+        def systemd_environment_lines
+          selected_environment.map do |key, value|
+            "Environment=#{key}=#{value.to_s.gsub("\\", "\\\\").gsub(" ", "\\x20")}"
+          end.join("\n")
+        end
+
+        def launchd_environment_lines
+          selected_environment.map do |key, value|
+            "    <key>#{CGI.escapeHTML(key)}</key>\n    <string>#{CGI.escapeHTML(value)}</string>"
+          end.join("\n")
+        end
+      end
+    end
+  end
+end
diff --git a/lib/hive/paths.rb b/lib/hive/paths.rb
index 752a5c7d..375d53ba 100644
--- a/lib/hive/paths.rb
+++ b/lib/hive/paths.rb
@@ -36,6 +36,14 @@ module Hive
       File.expand_path(env_or_blank("XDG_BIN_HOME") || File.join(home, ".local/bin"))
     end
 
+    # Versioned native Rails bundles live in data_home because they are
+    # immutable application assets, not mutable service state. Keeping them
+    # separate from state_home means a web upgrade never changes the daemon's
+    # queue, PID, or SQLite runtime databases.
+    def web_app_home
+      File.join(data_home, "web")
+    end
+
     # True when HIVE_HOME collapses every XDG directory onto one path:
     # state_home == config_home == data_home == cache_home. Uninstall uses
     # this to refuse deletes like `rm_rf(config_home)`, which would also
diff --git a/lib/hive/pid_file.rb b/lib/hive/pid_file.rb
index 9c58113a..0c4d7c35 100644
--- a/lib/hive/pid_file.rb
+++ b/lib/hive/pid_file.rb
@@ -57,13 +57,16 @@ module Hive
       nil
     end
 
-    def pid_file_payload(pid, start_time = nil)
+    def pid_file_payload(pid, start_time = nil, executable: nil, version: nil)
       start_time ||= Hive::Lock.process_start_time(pid)
-      {
+      payload = {
         "pid" => pid,
         "process_start_time" => start_time,
         "started_at" => Time.now.utc.iso8601
       }
+      payload["executable"] = executable if executable
+      payload["version"] = version if version
+      payload
     end
 
     def send_signal_safely(pid, signal)
